#
# Conditional build:
%bcond_without	python3	# CPython 3.x module

# full version number as seen on youtube-dl website
%define	verlong	2019.10.22

# transform version so we don't have to bump epoch after four digit upgrades:
# 2013.01.17.1 becomes 20130117_1
# 2013.01.28   becomes 20130128
# $ rpmvercmp 20130117_1 20130128
# 20130117_1 < 20130128
%define	ver	%(echo %{verlong} | awk -F. 'NF == 3 {printf("%s%s%s", $1, $2, $3)} NF == 4 {printf("%s%s%s_%s", $1, $2, $3, $4)}')
Summary:	Video extraction utility for YouTube
Summary(pl.UTF-8):	Narzędzie do wydobywania filmów z YouTube
Name:		youtube-dl
Version:	%{ver}
Release:	2
Epoch:		2
License:	Public Domain
Group:		Applications/System
Source0:	http://youtube-dl.org/downloads/%{verlong}/%{name}-%{verlong}.tar.gz
# Source0-md5:	49346e6d978b61039e0ab229730fd8e4
Source1:	%{name}.conf
# should be downloaded from:
# https://github.com/rg3/youtube-dl/pull/10291.diff
# but the author removed his repository, so the url is 404
# git log -p --reverse pr/10291~3..pr/10291
Patch0:		10291.diff
URL:		http://youtube-dl.org/
BuildRequires:	python-modules >= 1:2.6
BuildRequires:	python-setuptools
%if %{with python3}
BuildRequires:	python3-modules >= 1:3.2
BuildRequires:	python3-setuptools
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.720
Requires:	python-setuptools
Requires:	python-%{name} = %{epoch}:%{version}-%{release}
Suggests:	ffmpeg
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
youtube-dl is a small command-line program to download videos from
YouTube.com.

%description -l pl.UTF-8
youtube-dl jest programem do ściągania plików video z YouTube.com.

%package -n bash-completion-%{name}
Summary:	Bash completion for youtube-dl command
Summary(pl.UTF-8):	Bashowe dopełnianie parametrów polecenia youtube-dl
Group:		Applications/Shells
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	bash-completion >= 2.0

%description -n bash-completion-%{name}
Bash completion for youtube-dl command.

%description -n bash-completion-%{name} -l pl.UTF-8
Bashowe dopełnianie parametrów polecenia youtube-dl.

%package -n fish-completion-%{name}
Summary:	Fish completion for youtube-dl command
Summary(pl.UTF-8):	Dopełnianie parametrów w fish dla polecenia youtube-dl
Group:		Applications/Shells
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	fish

%description -n fish-completion-%{name}
Fish completion for youtube-dl command.

%description -n fish-completion-%{name} -l pl.UTF-8
Dopełnianie parametrów w fish dla polecenia youtube-dl.

%package -n python-%{name}
Summary:	Python 2 video extraction utility for YouTube
Summary(pl.UTF-8):	Narzędzie do wydobywania filmów z YouTube dla Pythona 2
Group:		Libraries/Python
Requires:	python-pyxattr >= 0.5.0

%description -n python-%{name}
Python 2 video extraction utility for YouTube.

%description -n python-%{name} -l pl.UTF-8
Narzędzie do wydobywania filmów z YouTube dla Pythona 2.

%package -n python3-%{name}
Summary:	Python 3 video extraction utility for YouTube
Summary(pl.UTF-8):	Narzędzie do wydobywania filmów z YouTube dla Pythona 3
Group:		Libraries/Python
Requires:	python3-pyxattr >= 0.5.0

%description -n python3-%{name}
Python 3 video extraction utility for YouTube.

%description -n python3-%{name} -l pl.UTF-8
Narzędzie do wydobywania filmów z YouTube dla Pythona 3.

%package -n zsh-completion-%{name}
Summary:	Zsh completion for youtube-dl command
Summary(pl.UTF-8):	Dopełnianie parametrów w zsh dla polecenia youtube-dl
Group:		Applications/Shells
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	zsh

%description -n zsh-completion-%{name}
Zsh completion for youtube-dl command.

%description -n zsh-completion-%{name} -l pl.UTF-8
Dopełnianie parametrów w zsh dla polecenia youtube-dl.

%prep
%setup -qc
%{__mv} %{name} .tmp; %{__mv} .tmp/* .
%patch0 -p1

%build
%py_build

%if %{with python3}
%py3_build
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python3}
%py3_install
%endif

%py_install
%py_postclean

install -d $RPM_BUILD_ROOT%{_sysconfdir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}

install -d $RPM_BUILD_ROOT{%{bash_compdir},%{fish_compdir},%{zsh_compdir}}
%{__mv} $RPM_BUILD_ROOT%{_prefix}/etc/bash_completion.d/youtube-dl.bash-completion \
	$RPM_BUILD_ROOT%{bash_compdir}/%{name}
%{__mv} $RPM_BUILD_ROOT%{_prefix}/etc/fish/completions/youtube-dl.fish \
	$RPM_BUILD_ROOT%{fish_compdir}/%{name}.fish
cp -p youtube-dl.zsh $RPM_BUILD_ROOT%{zsh_compdir}/_youtube-dl
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/youtube_dl

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README.md LICENSE
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/youtube-dl.conf
%attr(755,root,root) %{_bindir}/youtube-dl
%{_mandir}/man1/youtube-dl.1*

%files -n bash-completion-%{name}
%defattr(644,root,root,755)
%{bash_compdir}/%{name}

%files -n fish-completion-%{name}
%defattr(644,root,root,755)
%{fish_compdir}/%{name}.fish

%files -n python-%{name}
%defattr(644,root,root,755)
%{py_sitescriptdir}/youtube_dl
%{py_sitescriptdir}/youtube_dl-*-py*.egg-info

%if %{with python3}
%files -n python3-%{name}
%defattr(644,root,root,755)
%{py3_sitescriptdir}/youtube_dl
%{py3_sitescriptdir}/youtube_dl-*-py*.egg-info
%endif

%files -n zsh-completion-%{name}
%defattr(644,root,root,755)
%{zsh_compdir}/_youtube-dl
%changelog
* Mon Oct 28 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/youtube-dl.git;a=log;h=auto/th/youtube-dl-20191022-2

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> f7f09f5
- rebuild with python 3.8
- release 2 (by relup.sh)

* Sun Oct 27 2019 Adam Osuchowski <adwol@pld-linux.org> 1393f78
- up to 2019.10.22

* Sat Oct 12 2019 Adam Gołębiowski <adamg@pld-linux.org> 3a28f5c
- updated to 2019.09.28

* Fri Sep 20 2019 Adam Osuchowski <adwol@pld-linux.org> 689a502
- up to 2019.09.12.1

* Sun Aug 11 2019 Adam Osuchowski <adwol@pld-linux.org> 14f558e
- up to 2019.08.02

* Sat Jun 22 2019 Jan Palus <atler@pld-linux.org> 41d326d
- up to 20190621

* Sat May 11 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 7e83a62
- up to 20190511

* Wed May 08 2019 Elan Ruusamäe <glen@pld-linux.org> f170e1b
- up to 2019.04.30

* Wed Apr 24 2019 Adam Osuchowski <adwol@pld-linux.org> fe83fe6
- up to 2019.04.24

* Wed Apr 10 2019 Adam Gołębiowski <adamg@pld-linux.org> 0e8aa68
- updated to 2019.04.07

* Thu Apr 04 2019 Adam Gołębiowski <adamg@pld-linux.org> c62704e
- updated to 2019.04.01

* Mon Mar 18 2019 Adam Gołębiowski <adamg@pld-linux.org> 7a31795
- updated to 2019.03.18

* Mon Mar 11 2019 Adam Gołębiowski <adamg@pld-linux.org> 099476d
- updated to 2019.03.09

* Sat Mar 02 2019 Adam Gołębiowski <adamg@pld-linux.org> 6894a1d
- updated to 2019.03.01

* Mon Feb 18 2019 Adam Gołębiowski <adamg@pld-linux.org> cca9a6c
- updated to 2019.02.18

* Sat Feb 09 2019 Adam Gołębiowski <adamg@pld-linux.org> 77c44c9
- updated to 2019.02.08

* Sun Feb 03 2019 Adam Gołębiowski <adamg@pld-linux.org> 56ba859
- updated to 2019.01.30.1

* Thu Jan 24 2019 Jakub Bogusz <qboosh@pld-linux.org> ca858d4
- adjusted python* descriptions (no command-line)
- python3- package requires pyxattr too
- added python3 bcond

* Thu Jan 24 2019 Adam Gołębiowski <adamg@pld-linux.org> 3957f89
- updated to 2019.01.24

* Fri Jan 18 2019 Adam Gołębiowski <adamg@pld-linux.org> 9280a9c
- updated to 2019.01.17

